#include <stdio.h>
#include <iostream>
#include <string>
#include <assert.h>

using namespace std;

long long bstoi(string s)
{
	int res = 0;
	int m = 1;
	for(int i=s.length()-1; i>=0; i--)
	{
		res += m*(s[i]-'0');
		m*=2;
	}
	return res;	
}

string itobs(long long x)
{
	if (x == 0) return "0";

	string res = "";
	while(x > 0)
	{
		if (x%2==0) res.push_back('0');
		else res.push_back('1');
		x/=2;
	}
	string ans(res.rbegin(), res.rend());
	return ans;
}
void fill(int n, char ch)
{
	while (n)
	{
		cout << ch;
		n--;
	}
}

void space(int n)
{
	fill(n, ' ');
}

void dash(int n)
{
	fill(n, '-');
}

void zero(int n)
{
	fill(n, '0');
}
/*
void testgen(int test)
{
	int maxval = 1073741823;
	for(int i=0; i<test/4; i++)
	{
		int x = rand()%maxval;
		int y = rand()%maxval;

		cout << itobs(x) << ' ' << itobs(y) << endl;
	}

	for(int i=0; i<test/4; i++)
	{
		int x = rand()*rand()%maxval;
		int y = rand()%maxval;

		cout << itobs(x) << ' ' << itobs(y) << endl;
	}

	for(int i=0; i<test/4; i++)
	{
		int x = rand()%maxval;
		int y = rand()*rand()%maxval;

		cout << itobs(x) << ' ' << itobs(y) << endl;
	}

	for(int i=0; i<test/4; i++)
	{
		int x = rand()*rand()%maxval;
		int y = rand()*rand()%maxval;

		cout << itobs(x) << ' ' << itobs(y) << endl;
	}
}
*/
int main()
{
	//freopen("binary.out", "w", stdout);

	//testgen(100);
	//return 0;

	int t = 0;
	cin >> t;
	for(int test=0; test < t; test++)
	{
		cout << "Test " << test+1 << endl;

		string x, y;
		cin >> x >> y;
				
		int xl, yl;
		xl = x.length();
		yl = y.length();
				
		if (xl > 30 || yl > 30) assert("Invalid data");
		if (x[0] == '0' && xl > 1) assert("Invalid data");
		if (y[0] == '0' && yl > 1) assert("Invalid data");

		long long a = bstoi(x);
		long long b = bstoi(y);
		long long c = a*b;
		string z = itobs(c);
		int zl = z.length();

		int maxxyl = max(xl, yl);
		int maxl = max(zl, maxxyl);

		space(maxl - xl);
		cout << x << endl;
		space(maxl - yl);
		cout << y << endl;
		
		space(maxl - maxxyl);
		dash(maxxyl);
		cout << endl;

		for(int i=0; i<yl; i++)
		{
			space(maxl - xl - i);
			if (y[yl-1-i] == '1') cout << x;
			else zero(xl);
			cout << endl;
		}

		dash(maxl);
		cout << endl;
		space(maxl-zl);
		cout << z << endl;		
		cout << endl;
	}

	return 0;
}