#include <iostream>
#include <cstdlib>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <ctime>
#include <vector>
#include <string>
#include <ctime>
#include <queue>
#include <map>
#include <set>

#ifdef WIN32
    #define I64 "%I64d"
#else
    #define I64 "%lld"
#endif // WIN32

#define next(x) (x + ((x) & (-x)))
#define prev(x) (x - ((x) & (-x)))
#define N 100001
#define md 1000000000
#define sqr(x) ((x) * (x))
#define INF (1 << 30)
#define EPS 0.00000001

using namespace std;
long long t, n, m, k, s;
vector<long long> a;
vector<long long> b;
vector<long long> d1;
vector<long long> d2;

int main() {
    #ifdef DEBUG
        freopen("input.txt", "r", stdin);
        //freopen("output.txt", "w", stdout);
    #else
        //freopen("input.txt", "r", stdin);
        //freopen("output.txt", "w", stdout);
    #endif // DEBUG

    srand(time(NULL));
    cin >> t;
    for (long long i = 0; i < t; i++) {
        a.clear();
        b.clear();
        cin >> n >> m;
        cin >> k;
        for (long long j = 0; j < k; j++) {
            long long x;
            cin >> x;
            a.push_back(x);
        }
        sort(a.begin(), a.end());
        for (long long j = 1; j < a.size(); j++) {
            if (a[j] == a[j - 1]) {
                a.erase(a.begin() + j, a.begin() + j + 1);
                j--;
            }
        }
        cin >> s;
        for (long long j = 0; j < s; j++) {
            long long x;
            cin >> x;
            b.push_back(x);
        }
        sort(b.begin(), b.end());
        for (long long j = 1; j < b.size(); j++) {
            if (b[j] == b[j - 1]) {
                b.erase(b.begin() + j, b.begin() + j + 1);
                j--;
            }
        }
        d1.clear();
        d2.clear();
        d1 = vector<long long> (100001, 0);
        d2 = vector<long long> (100001, 0);
        d1[n] = 1;
        d2[n] = 1;
        for (long long j = n; j < m; j++) {
            for (long long z = 0; z < a.size(); z++) {
                if (j + a[z] < m + 1) {
                    d1[j + a[z]] += d1[j];
                    if (j != n) {
                        d1[j + a[z]] += d2[j];
                    }
                    d1[j + a[z]] %= md;
                }
            }
            for (long long z = 0; z < b.size(); z++) {
                if (j * b[z] < m + 1) {
                    if (j != n) {
                        d2[j * b[z]] += d1[j];
                    }
                    d2[j * b[z]] += d2[j];
                    d2[j * b[z]] %= md;
                }
            }
        }
        if (d2[m] < 0) {
            d2[m] += md;
        }
        cout << d2[m]<< endl;
    }

    return 0;
}
