#include <set>
#include <map>
#include <queue>
#include <deque>
#include <vector>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <iostream>
#include <algorithm>
using namespace std;

#define left first
#define right second
#define pb push_back
#define mp make_pair
#define sz(a) ((int)a.size())
#define all(a) a.begin(), a.end()
#define ms(a, x) memset(a, x, sizeof a)

typedef long long ll;
typedef vector<int> vi;
typedef pair<int,int> pii;
typedef pair<pii, int> tri;

const int N = 1<<17;
const int inf = 1<<30;

char a[100], b[100];

void out(string s, int w, int k) {
	int n = sz(s);
	for (int i = 0; i < w-n-k; i++)
		putchar(' ');
	cout << s << endl;
}

int main() {
	#ifdef LOCAL
	freopen("a.in", "r", stdin);
	freopen("a.out", "w", stdout);
	#endif

	int T;
	scanf("%d", &T);
	for (int t = 1; t <= T; t++) {
		scanf("%s%s", a, b);
		int n = strlen(a);
		int m = strlen(b);
		ll A = 0, B = 0;
		for (int i = 0; i < n; i++) {
			if (a[i] == '1')
				A += 1LL<<(n-i-1);
		}
		for (int i = 0; i < m; i++) {
			if (b[i] == '1')
				B += 1LL<<(m-i-1);
		}
		ll C = A * B;
		string s = "";
		if (C == 0) s = "0";
		while (C) {
			s += ('0' + C % 2);
			C /= 2;
		}
		reverse(all(s));
		int k = sz(s);
		int w = max(max(n,m), k);
		printf("Test %d\n", t);
		out(string(a), w, 0);
		out(string(b), w, 0);
		string dif = "";
		for (int i = 0; i < max(n,m); i++) dif += '-';
		out(dif, w, 0);
		string z = "";
		for (int i = 0; i < n; i++) z += '0';
		for (int i = 0; i < m; i++) {
			if (b[m-i-1] == '0')
				out(z, w, i);
			else
				out(string(a), w, i);
		}
		for (int i = 0; i < w; i++) cout << '-'; cout << endl;
		out(s, w, 0);
		if (t < T) cout << endl;
	}

	return 0;
}
