#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cassert>

#include <iostream>
#include <iomanip>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <deque>
#include <queue>
#include <stack>
#include <algorithm>


#define forn(i, n) for(int i = 0; i < int(n); i++)
#define mp make_pair
#define pb push_back
#define foreach(it, v) for(__typeof(v.begin()) it = v.begin(); it != v.end(); ++it)

using namespace std;

typedef long long ll;


int main() {
	ios_base::sync_with_stdio(false);
	int tests;
	cin >> tests;
	for(int test = 0; test < tests; test++) {
		int n, k;
		cin >> n >> k;
		vector < ll > times(n);
		for(int i = 0; i < n; i++)
			cin >> times[i];
		ll result = 0;
		const ll inf = 1e14;
		ll l = 0, r = inf;
		while(r - l > 1) {
			ll m = (l + r) / 2;
			ll count = 0;
			for(int i = 0; i < n; i++)
				count += m / times[i];
			if(count >= k) r = m;
			else l = m;
		}
		cout << r << endl;
	}
	return 0;
}