#include <iostream>
using namespace std;


const int max_n = 1e5;

int n;
int a[max_n];
int k;

bool Check(long long t)
{
    long long cur_k = 0;
    for (int i = 0; i < n; ++i) {
        cur_k += t / a[i];
        if (cur_k >= k) {
            return true;
        }
    }

    return cur_k >= k;
}


int main()
{
    ios_base::sync_with_stdio(false);

    int tests;
    cin >> tests;
    for (int test = 0; test < tests; ++test) {
        cin >> n >> k;
        for (int i = 0; i < n; ++i) {
            cin >> a[i];
        }

        long long need_time = 1e18;
        long long bl = 1;
        long long br = 1e18;
        while (bl <= br) {
            long long bm = (bl + br) >> 1;

            if (Check(bm)) {
                need_time = bm;
                br = bm - 1;
            } else {
                bl = bm + 1;
            }
        }

        cout << need_time << endl;
    }

    return 0;
}
