#include <cstdio>
#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <memory.h>
#include <queue>
#include <deque>
#include <stack>
#include <list>
#include <map>
#include <set>
#include <functional>
#include <cstring>
#include <ctime>

using namespace std;

#define all(a) a.begin(), a.end()
#define mp make_pair

typedef long long li;
typedef long double ld;
typedef pair<int, int> pi;
typedef vector<int> vi;

#define FILENAME ""

void solve();
int main() {
#ifdef YA
	string s = FILENAME;
	//assert(!s.empty());
	clock_t start = clock();
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
	//freopen(FILENAME ".in", "r", stdin);
	//freopen(FILENAME ".out", "w", stdout);
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif
	cout.sync_with_stdio(0);
	cin.tie(0);
	cout.precision(15);
	cout << fixed;

	int t = 1;
	cin >> t;
	while(t--) {
		solve();
	}
#ifdef YA
	cout << "\n\n" << (clock() - start) / 1.0 / CLOCKS_PER_SEC << "\n\n";
#endif
	return 0;
}


//#define int li

const int mod = 1000000000;


vector<vi> dp(2, vi(101010));

void solve() {
	int n, m;
	cin >> n >> m;
	for(int i = n; i <= m; ++i) {
		dp[0][i] = dp[1][i] = 0;
	}


	dp[0][n] = 1;

	int k;
	cin >> k;
	vector<int> a(k);

	
	
	for(int i = 0; i < k;++i){
		cin >> a[i];
	}

	sort(all(a));
	a.erase(unique(all(a)), a.end());
	k = a.size();


	int l;
	cin >> l;
	vi b(l);
	for(int i = 0; i < l; ++i) {
		cin >> b[i];
	}


	
	sort(all(b));
	b.erase(unique(all(b)), b.end());
	l = b.size();
	for(int i = n; i < m; ++i) {
		for(int j = 0; j < 2; ++j) {
			for(int t = 0; t < k; ++t) {
				if(a[t] + i > m)
					continue;
				dp[0][i + a[t]] += dp[j][i];
				dp[0][i + a[t]] %= mod;
			}

			for(int t = 0; t < l; ++t) {
				if(b[t] * i > m)
					continue;
				dp[1][i * b[t]] += dp[j][i];
				dp[1][i * b[t]] %= mod;
			}
		}
	}


	cout << dp[1][m] << '\n';

}