#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <iostream>
#include <string>
#include <vector>
#include <memory.h>
#include <algorithm>
#include <map>
#include <set>
#include <queue>

using namespace std;

#define fore(i, b, e) for (int i = (int)b; i <= (int)e; i++)
#define forn(i, n) for (int i = 0; i < (int)n; i++)
#define fi first
#define se second
#define pii pair <int, int>
#define mp make_pair
#define i64 long long
#define li long long
#define vi vector <int>

int n;
int a[100100];
int t[500100];
int ans[100100];

int get(int v, int vl, int vr, int l, int r) {
	//cerr << vl << ' ' << vr << ' ' << ' ' << l << ' '  << r << ' ' << t[v] << endl;
	if (l >= r)
		return 0;
	if (vl == l && vr == r) {
		//cerr << t[v] << endl;
		return t[v];
	}
	int d = (vl + vr) / 2;
	return get(v * 2, vl, d, l, min(d, r)) +
		get(v * 2 + 1, d, vr, max(l, d), r);
}

void put(int v, int vl, int vr, int pos, int val) {
	//cerr << vl << ' ' << vr << ' ' << pos << endl;
	//cerr << t[v] << endl;
	if (vl + 1 == vr) {
		t[v] = val;
		//cerr << t[v] << endl;
		return;
	}
	int d = (vl + vr) / 2;
	if (pos < d) {
		put(v * 2, vl, d, pos, val);
	} else {
		put(v * 2 + 1, d, vr, pos, val);
	}
	t[v] = t[v * 2] + t[v * 2 + 1];
	// cerr << t[v] << ' ' << t[v * 2] << ' ' << t[v * 2 + 1] << endl;
}

void solve() {
	scanf("%d", &n);
	for (int i = 0; i < n; i++) 
		scanf("%d", &a[i]);
	memset(t, 0, sizeof(t));
	for (int i = n - 1; i >= 0; i--) {
		ans[i] = get(1, 1, n + 1, 1, a[i]); 
		// cerr << get(1, 1, n + 1, a[i] + 1, n + 1) << endl;
		put(1, 1, n + 1, a[i], 1);
		//cerr << endl;
	}
	for (int i = 0; i < n; i++)
		printf("%d ", ans[i]);
	printf("\n");
}

int main()
{
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	int n;
	scanf("%d", &n);
	for (int i = 0; i < n; i++)
		solve();
}