#include <bits/stdc++.h>

#define pb push_back
#define mp make_pair
#define all(x) (x).begin(), (x).end()
#define x first
#define y second
#define in(n) int (n) = nxt()

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef int itn;
typedef pair<int, int> PII;

int nxt() {
    int res;
    scanf("%d", &res);
    return res;
}

int n, m;

int used[40][40];

char can1(int x, int y) {
    for (int i = 0; i < 3; ++i) {
        for (int j = 0; j < 2; ++j) {
            if (used[x + i][y + j]) return false;
        }
    }
    return true;
}

void put1(int x, int y, int v) {
    for (int i = -1; i < 4; ++i) {
        for (int j = -1; j < 3; ++j) {
            used[x + i][y + j] += v;
        }
    }
}

char can2(int x, int y) {
    for (int i = 0; i < 2; ++i) {
        for (int j = 0; j < 3; ++j) {
            if (used[x + i][y + j]) return false;
        }
    }
    return true;
}

void put2(int x, int y, int v) {
    for (int i = -1; i < 3; ++i) {
        for (int j = -1; j < 4; ++j) {
            used[x + i][y + j] += v;
        }
    }
}

int ans = 0;

void rec(int x, int y, int cnt) {
    if (y == m + 5) {
        rec(x + 1, 5, cnt);
        return;
    }
    if (x == n + 5) {
        ans = max(ans, cnt);
        return;
    }
    if (can1(x, y)) {
        put1(x, y, 1);
        rec(x, y + 1, cnt + 1);
        put1(x, y, -1);
    }
    if (can2(x, y)) {
        put2(x, y, 1);
        rec(x, y + 1, cnt + 1);
        put2(x, y, -1);
    }
    rec(x, y + 1, cnt);
}

void solve(){
    in(t);
    while (t--) {
        n = nxt(), m = nxt();
        memset(used, 0x3f, sizeof(used));
        for (int i = 1; i + 1 < n; ++i) {
            for (int j = 1; j + 1 < m; ++j) {
                used[i + 5][j + 5] = 0;
            }
        }
        in(b);
        for (int i = 0; i < b; ++i) {
            in(x); in(y); in(w); in(h);
            x += 5, y += 5;
            for (int j = x - 1; j < x + w + 1; ++j) {
                for (int k = y - 1; k < y + h + 1; ++k) {
                    used[j][k] = 1;
                }
            }
        }
        ans = 0;
        rec(5, 5, 0);
        cout << ans << "\n";
    }

}

int main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif // LOCAL

    solve();

    return 0;
}
