#include <bits/stdc++.h>
using namespace std;

#ifdef SG
	#include "debug/debug.h"
#else
	#define show(...)
	#define debug(...)
	#define deepen(...)
	#define timer(...)
#endif

#define forn(i,n) for (int i = 0; i < int(n); ++i)
#define ford(i,n) for (int i = int(n) - 1; i >= 0; --i)
#define ve vector
#define pa pair
#define tu tuple
#define mp make_pair
#define mt make_tuple
#define pb push_back
#define fs first
#define sc second
#define all(a) (a).begin(), (a).end()
#define sz(a) ((int)(a).size())

typedef long double ld;
typedef long long ll;
typedef unsigned long long ull;
typedef unsigned int ui;
typedef unsigned char uc;
typedef pa<int, int> pii;
typedef pa<int, ll> pil;
typedef pa<ll, int> pli;
typedef pa<ll, ll> pll;
typedef ve<int> vi;

const ld pi = 3.1415926535897932384626433832795l;

template<typename T> inline auto sqr (T x) -> decltype(x * x) {return x * x;}
template<typename T> inline T abs (T x) {return x > T() ? x : -x;}
template<typename T1, typename T2> inline bool umx (T1& a, T2 b) {if (a < b) {a = b; return 1;} return 0;}
template<typename T1, typename T2> inline bool umn (T1& a, T2 b) {if (b < a) {a = b; return 1;} return 0;}

struct Input {
	int n, m;
	ve<pii> ed;
	
	bool read () {
		if (!(cin >> n >> m)) {
			return 0;
		}
		forn (i, m) {
			int u, v;
			scanf("%d%d", &u, &v);
			--u, --v;
			ed.pb(mp(u, v));
		}
		return 1;
	}

	void init (const Input &input) {
		*this = input;
	}
};

struct Data: Input {
	int ans;
	void write () {
		printf("%d\n", ans);
	}
	
	virtual void solve () {}
	
	virtual void clear () {
		*this = Data();
	}
};

const int N = 200;
const int M = 1000;
const int inf = 1e9;

struct Solution: Data {
	ve<pii> g[N];
	bool isDel[M];
	int d[N];
	
	void bfs (int st) {
		fill(d, d + n, inf);
		d[st] = 0;
		queue<int> t;
		t.push(st);
		while (!t.empty()) {	
			int u = t.front();
			t.pop();
			
			for (int i = 0; i < sz(g[u]); ++i) {
				int e = g[u][i].sc, v = g[u][i].fs;
				if (isDel[e]) {
					continue;
				}
				if (umn(d[v], d[u] + 1)) {
					t.push(v);
				}
			}
		}
	}
	
	void solve () {
		forn (i, m) {
			int u = ed[i].fs, v = ed[i].sc;
			g[u].pb(mp(v, i));
			g[v].pb(mp(u, i));
		}
		
		ans = inf;
		memset(isDel, 0, sizeof isDel);
		forn (i, m) {
			isDel[i] = 1;
			bfs(ed[i].fs);
			ans = min(ans, d[ed[i].sc] + 1);
			isDel[i] = 0;
		}
	}
	
	void clear () {
		*this = Solution();
	}
};

Solution sol;

int main () {
	cout.setf(ios::showpoint | ios::fixed);
	cout.precision(20);
#ifdef SG
	freopen("d.in", "r", stdin);
//	freopen("output.txt", "w", stdout);
#else
//	freopen("", "r", stdin);
//	freopen("", "w", stdout);
#endif
	int t;
	cin >> t;
	forn (i, t) {
		sol.read();
		sol.solve();
		sol.write();
		sol.clear();
	}
	return 0;
}
