#include <iostream>
#include <fstream>
#include <ctime>
#include <cstdio>
#include <vector>
#include <map>
#include <algorithm>
#include <set>
#include <cstdlib>
#include <cstring>
#include <cmath>
#include <bitset>
#include <deque>
#include <stack>
#include <queue>
using namespace std;

#define fs first
#define sc second

#define pb push_back
#define mp make_pair

#define forn(i, n) for(int i = 0; i < (int)n; ++i)
#define all(x) (x).begin(), (x).end()

const int MAXN = 100 * 1000 + 5;
int fen[MAXN], a[MAXN], ans[MAXN];

void update(int i, int val) {
    for(; i < MAXN; i |= (i + 1))
        fen[i] += val;
}

int get(int i) {
    int res = 0;
    for(; i >= 0; i = (i & (i + 1)) - 1)
        res += fen[i];
    return res;
}

int main()
{
    ios_base::sync_with_stdio(false);
    int t;
    cin >> t;
    for(int tt = 0; tt < t; tt++) {
        int n;
        cin >> n;
        for(int i = 0; i < n; i++)
            cin >> a[i];
        for(int i = 0; i < MAXN; i++)
            fen[i] = 0;
        for(int i = n - 1; i >= 0; i--) {
            ans[i] = get(a[i]);
            update(a[i], 1);
        }
        for(int i = 0; i < n; i++)
            cout << ans[i] << ' ';
        cout << '\n';
    }
    return 0;
}
