#include <iostream>
#include <fstream>
#include <ctime>
#include <cstdio>
#include <vector>
#include <map>
#include <algorithm>
#include <set>
#include <cstdlib>
#include <cstring>
#include <cmath>
#include <bitset>
#include <deque>
#include <stack>
#include <queue>
using namespace std;

#define fs first
#define sc second

#define pb push_back
#define mp make_pair

#define forn(i, n) for(int i = 0; i < (int)n; ++i)
#define all(x) (x).begin(), (x).end()

int n;
map<int, bool> dp;

bool dfs(int v) {
    if(dp.find(v) != dp.end())
        return dp[v];
    if(v >= n)
        return dp[v] = false;
    for(int i = 2; i <= 9; i++)
        if(!dfs(i * v))
            return dp[v] = true;
    return dp[v] = false;
}

int main()
{
    ios_base::sync_with_stdio(false);
    int t;
    cin >> t;
    for(int tt = 0; tt < t; tt++) {
        cin >> n;
        dp.clear();
        cout << (dfs(1)? 1 : 2) << '\n';
    }
    return 0;
}
