#include <iostream>
#include <string>
#include <cstdlib>
#include <cstdio>
#include <algorithm>
#include <map>
#include <set>
#include <vector>
#include <cmath>
#include <cstring>
#include <queue>
#include <deque>
#include <functional>
#include <climits>
#include <list>

#define mp make_pair
#define mt(a, b, c) mp(a, mp(b, c))
#define ABS(a) (((a) > 0) ? (a) : (-(a)))
#define ZERO(x) memset((x), 0, sizeof(x))
#define NEGATE(x) memset((x), 255, sizeof(x))
#define X first
#define Y second

using namespace std;
typedef long long ll;
typedef unsigned long long ull;
//typedef unsigned long long ull;
typedef pair<ll, ll> ii;
typedef pair<ll, ii> iii;

const int maxval = 2e9;

map<ll, bool> dp;

ll w;

bool f(ll n)
{
	if (n * 9 >= w)
		return 1;
	if (dp.find(n) != dp.end())
		return dp[n];
	bool win = 0;
	for (ll i = 2; i <= 9; i++)
	{
		if (!f((ll)n * i))
		{
			win = 1;
			break;
		}
	}
	return dp[n] = win;
}

int main()
{
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);

	int tests;
	cin >> tests;
	for (int q = 0; q < tests; q++)
	{
		cin >> w;
		dp.clear();
		if (f(1))
			cout << 1 << endl;
		else
			cout << 2 << endl;
	}

	return 0;
}