#include <stdio.h>
#include <string.h>
#include <math.h>

#include <algorithm>
#include <string>
#include <map>
#include <unordered_map>
#include <set>
#include <vector>
#include <queue>
#include <deque>
#include <iostream>

using namespace std;
int T, na, nb, nrbit;
string A, B;
vector <int> v;
long long a, b;

inline int Nrbit(long long x)
{
    if(x == 0LL)
        return 1;
    int rez = 0;
    while(x)
    {
        rez++;
        x /= 2LL;
    }
    return rez;
}

int main ()
{
#ifdef local
    freopen ("b.in", "r", stdin);
    freopen ("b.out", "w", stdout);
#endif
    int i, t, poz, j;
    cin >> T;
    for(t = 1; t <= T; ++t)
    {
        A.clear();
        B.clear();
        cin >> A;
        cin >> B;
        na = A.size();
        nb = B.size();
        a = b = 0LL;
        for(i = 0; i < na; ++i)
            a = 2LL * a + A[i] - '0';
        for(i = 0; i < nb; ++i)
            b = 2LL * b + B[i] - '0';
        nrbit = Nrbit(a * b);
        nrbit = max(nrbit, max(na, nb));
        cout << "Test " << t << "\n";
        for(i = 1; i + na <= nrbit; ++i)
            cout << " ";
        cout << A << "\n";
        for(i = 1; i + nb <= nrbit; ++i)
            cout << " ";
        cout << B << "\n";
        for(i = 1; i + max(na, nb) <= nrbit; ++i)
            cout << " ";
        for(; i <= nrbit; ++i)
            cout << "-";
        cout << "\n";
        poz = nrbit - na;
        for(i = nb - 1; i >= 0; --i, poz--)
        {
            if(B[i] == '0')
            {
                for(j = 1; j <= poz; ++j)
                    cout << " ";
                for(j = poz + 1; j <= poz + na; ++j)
                    cout << "0";
                for(j = poz + na + 1; j <= nrbit; ++j)
                    cout << " ";
                cout << "\n";
            }
            else
            {
                for(j = 1; j <= poz; ++j)
                    cout << " ";
                cout << A;
                for(j = poz + na + 1; j <= nrbit; ++j)
                    cout << " ";
                cout << "\n";
            }
        }
        for(i = 1; i <= nrbit; ++i)
            cout << "-";
        cout << "\n";
        long long x = a * b;
        if(x == 0LL)
        {
            for(i = 1; i < nrbit; ++i)
                cout << " ";
            cout << "0\n";
        }
        else
        {
            v.clear();
            while(x)
            {
                v.push_back(x % 2LL);
                x /= 2LL;
            }
            for(i = v.size() - 1; i >= 0; --i)
                cout << v[i];
            cout << "\n";
        }
        cout << "\n";
    }
    return 0;
}
