#include <stdio.h>
#include <string.h>
#include <math.h>

#include <algorithm>
#include <string>
#include <map>
#include <unordered_map>
#include <set>
#include <vector>
#include <queue>
#include <deque>
#include <iostream>
#define MOD 2017
using namespace std;
int T, n, K;
int comb[15][15];

inline int Put(int baz, int put)
{
    int rez = 1;
    while(put)
    {
        if(put % 2 == 1)
        {
            rez = (1LL * rez * baz) % MOD;
            put--;
        }
        baz = (1LL * baz * baz) % MOD;
        put /= 2;
    }
    return rez;
}

int main ()
{
#ifdef local
    freopen ("k.in", "r", stdin);
    freopen ("", "w", stdout);
#endif
    int i, j;
    comb[0][0] = 1;
    for(i = 1; i <= 11; ++i)
    {
        comb[i][0] =  comb[i][i] = 1;
        for(j = 1; j < i; ++j)
        {
            comb[i][j] = comb[i - 1][j] + comb[i - 1][j - 1];
            if(comb[i][j] >= MOD)
                comb[i][j] -= MOD;
        }
    }
    cin >> T;
    while(T--)
    {
        cin >> n >> K;
        int sol = 0, semn = 1, fact = 1;
        for(i = 2; i <= K; ++i)
            fact = (1LL * fact * i) % MOD;
        for(i = 0; i <= K; ++i, semn = - semn)
        {
            sol += (semn * Put(K - i, n) * comb[K][i]) % MOD;
            if(sol >= MOD)
                sol -= MOD;
        }
        sol = (1LL * sol * Put(fact, MOD - 2)) % MOD;
        cout << sol << "\n";
    }
    return 0;
}
