#if 1
#include <functional>
#include <algorithm>
#include <iostream>
#include <iterator>
#include <iomanip>
#include <sstream>
#include <numeric>
#include <string>
#include <vector>
#include <bitset>
#include <queue>
#include <stack>
#include <map>
#include <set>
#include <cstdlib>
#include <cassert>
#include <cstring>
#include <cstdio>
#include <cmath>
#include <ctime>
#include <list>
 
using namespace std;
 
typedef long long LL;
typedef long double LD;
typedef pair<int, int> pii;
 
const LD eps = 1e-9;
const LD pi = acos(-1.0);
const LL inf = 1e+9;
 
#define mp make_pair
#define pb push_back
#define X first
#define Y second
 
#define dbg(x) { cerr << #x << " = " << x << endl; }
 
// extended template
#pragma comment(linker, "/STACK:36777216")
typedef vector<int> vi;
typedef vector<vi> vvi;
 
#define forn(i, n) for (int i = 0; i < n; ++i)
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
 
template<typename T> istream & operator >> (istream &, vector<T> &);
template<typename T> ostream & operator << (ostream &, const vector<T> &);
 
#define START clock_t _clock = clock();
#define END cerr << endl << "time: " << (clock() - _clock) / LD(CLOCKS_PER_SEC) << endl;
 
#define NAME "problem"

int n, a[111], res, d[111], dmax;

void readin(){
    cin >> n;
    for (int i = 1; i <= n; i++)
        cin >> a[i];
}

void init(){
    res = 0;
    dmax = 0;
    sort(a + 1, a + n + 1);
    memset(d, 0, sizeof(d));
}

void process(){
    for (int i = n; i >= 1; i--){
        while (a[i] > 18){
            if (a[i] % 10 != 0){
                res++;
                a[i] -= a[i] % 10;
            } else{
                a[i] /= 10;
                if (d[i] == dmax){
                    d[i]++;
                    dmax++;
                    res++;
                } else d[i]++;
            }
        }
    }
    
    int cnt = 0;
    for (int i = 1; i <= n; i++)
        if (a[i] == 10 && d[i] == dmax){
            cnt++;
        }
    if (cnt >= 2){
        res++;
        for (int i = 1; i <= n; i++){
            if (a[i] == 10) res++;
            else res += (a[i] + 8) / 9;
        }
    } else{
        for (int i = 1; i <= n; i++)
            res += (a[i] + 8) / 9;
    }
    
    cout << res << endl;
}

void solve()
{
    int test;
    cin >> test;
    while (test--){
        readin();
        init();
        process();
    }
}
 
int main()
{
    // freopen(NAME ".in", "r", stdin); freopen(NAME ".out", "w", stdout);
    //freopen("input.txt", "r", stdin); // freopen("output.txt", "w", stdout);
 
    solve();
 
    return 0;
}
/*******************************************
*******************************************/
 
template<typename T> istream & operator >> (istream &is, vector<T> &v)
{
    forn(i, v.size())
        is >> v[i];
    return is;
}
template<typename T> ostream & operator << (ostream &os, const vector<T> &v)
{
    forn(i, v.size())
        os << v[i] << " ";
    return os;
}
#endif