#include <iostream>
#include <cstdio>
#include <string>
#include <cstring>
#include <map>
#include <set>
#include <stack>
#include <queue>
#include <vector>
#include <cmath>
#include <algorithm>
#include <ctime>
#include <cstdlib>
#include <cassert>

using namespace std;
#define forn(i, n) for (int i = 0; i < n; ++i)
#define ALL(a) a.begin(), a.end()
#define X first
#define Y second
#define sz(a) ((int)a.size())
#define L(a) sz(a)
#define pb(a) push_back(a)
#define mp(a, b) make_pair(a, b)
#define ms(a) memset(a,0,sizeof(a))
#define ms1(a) memset(a,-1,sizeof(a))

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int, int> pii;

const double PI = 3.1415926535897932384626433832795;

const int mod = 1000000000;

void add(int& x, int y) {
	x += y;
	if (x >= mod) x -= mod;
}

void solve() {
	int n, m; scanf("%d%d", &n, &m);
	int K; scanf("%d", &K);
	vector<int> a(K);
	forn(i, K) scanf("%d", &a[i]);
	sort(ALL(a)), a.erase(unique(ALL(a)), a.end());
	int S; scanf("%d", &S);
	vector<int> b(S);
	forn(i, S) scanf("%d", &b[i]);
	sort(ALL(b)), b.erase(unique(ALL(b)), b.end());
	vector<int> dp(m+1);
	dp[n] = 1;
	for (int i = n+1; i <= m; ++i) {
		forn(jj, sz(b)) {
			if (i%b[jj]) continue;
			add(dp[i], dp[i/b[jj]]);
		}
		if (i == m) {printf("%d\n", dp[m]); return;}
		forn(jj, sz(a)) {
			int cur = a[jj];
			int pred = i-cur;
			if (pred >= 0) add(dp[i], dp[pred]);
		}
	}
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
	/*freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);*/
#endif
	int T; scanf("%d", &T); while (T--) solve();
	return 0;
}
