#include <iostream>
#include <cmath>
#include <string>
#include <algorithm>
#include <cstring>
#include <cstdio>
#include <fstream>
#include <cassert>
#include <map>
#include <set>
#include <vector>
#include <queue>
#include <stack>
#include <functional>
#include <numeric>
#include <ctime>
#include <cstdlib>
#include <sstream>

using namespace std;

#define f first
#define s second
#define mp make_pair
#define pb push_back
#define pii pair<int, int>
#define pll pair<long long, long long>
#define y1 stupid_y1
#define ll long long
#define vi vector<int>
#define forit(it, s) for(__typeof(s.begin()) it = s.begin(); it != s.end(); it++)
#define all(a) a.begin(), a.end()
#define sqr(x) ((x)*(x))
#define sz(a) (int)a.size()
#define file "a"

const int maxn = (int)1e5+11;
const int inf = int(1e9);
const int mod = inf + 7;
const double eps = 1e-9;
const double pi = acos(-1.0);

int T[4*maxn];
int a[maxn];
int n;
int ans[maxn];

void update(int v, int tl, int TR, int pos, int val){
	if(tl == TR) T[v] += val;
	else {
		int mid = (tl + TR) >> 1;
		if(pos <= mid) update(2*v, tl, mid, pos, val);
		else update(2*v+1, mid+1, TR, pos, val);
		T[v] = T[2*v] + T[2*v+1];
	}
}

int getsum(int v, int tl, int tr, int l, int r) {
	if(l > r) return 0;
	if(l == tl && r == tr) return T[v];
	int mid = (tl + tr) >> 1;
	int ans1 = getsum(2 * v, tl, mid, l, min(r, mid));
	int ans2 = getsum(2 * v + 1, mid+1, tr, max(mid+1, l), r);
	return ans1 + ans2;
}

void Solve(){
	scanf("%d", &n);
	memset(T, 0, sizeof(T));

	for (int i=0;i<n;i++){
		scanf("%d", &a[i]);
		a[i]--;
	}

	for(int i = n-1; i >= 0; i--) {
		ans[i] = getsum(1, 0, n-1, 0, a[i]);
		update(1, 0, n-1, a[i], 1);
	}

	for (int i=0;i<n;i++){
		printf("%d ", ans[i]);
	}
	printf("\n");

}

int main () {

	#ifdef LOCAL
	freopen(file".in", "r", stdin);
	freopen(file".out", "w", stdout);
	#endif

	int t;
	scanf("%d", &t);

	for (int i=0;i<t;i++){
		Solve();			
	}

	#ifdef LOCAL
	cerr << (double)clock() * 1.0 / CLOCKS_PER_SEC << endl;
	#endif

	return 0;
}
