#include <set>
#include <map>
#include <queue>
#include <deque>
#include <vector>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <iostream>
#include <algorithm>
using namespace std;

#define left first
#define right second
#define pb push_back
#define mp make_pair
#define sz(a) ((int)a.size())
#define all(a) a.begin(), a.end()
#define ms(a, x) memset(a, x, sizeof a)

typedef long long ll;
typedef vector<int> vi;
typedef pair<int,int> pii;
typedef pair<pii, int> tri;

const int N = 1<<17;
const int inf = 1<<30;

int a[N], t[N], ans[N];

int get(int val) {
	int res = 0;
	for (int i = val; i >= 0; i = (i & (i+1)) - 1)
		res += t[i];
	return res;
}

void inc(int v) {
	for (int i = v; i < N; i |= i+1)
		t[i]++;
}

int main() {
	#ifdef LOCAL
	freopen("a.in", "r", stdin);
	freopen("a.out", "w", stdout);
	#endif

	int T, n;
	scanf("%d", &T);
	while (T--) {
		scanf("%d", &n);
		for (int i = 0; i < n; i++) {
			scanf("%d", &a[i]);
		}
		ms(t, 0);
		for (int i = n-1; i >= 0; i--) {
			ans[i] = get(a[i]-1);
			inc(a[i]);
		}
		for (int i = 0; i < n; i++)
			printf("%d ", ans[i]);
		printf("\n");
	}

	return 0;
}
