#include <iostream>
#include <vector>
#include <deque>
#include <set>
#include <cstdio>

using namespace std;

int sum(int r, vector<int>& a)
{
	int ans = 0;
	for(;r>=0;r = (((r+1)&r) - 1))
	{
		//cerr << "Fen looks at " << r <<endl;
		ans += a[r];
	}
	return ans;
}

void update(int new_val, int i, vector<int>& a)
{
	for(; i < a.size(); i = (i+1)|i)
		a[i] += new_val;
}

void solve()
{
	int n;
	cin >> n;
	vector<int> a(n+1), b(n), ans(n);
	for(int i = 0; i < n; i++)
		cin >> b[i];
	for(int i = n-1; i >= 0; i--)
	{
		ans[i] = sum(b[i], a);
		update(1, b[i], a);
	}
	for(int i = 0; i < n; i++)
	{
		cout << ans[i] << ' ';
	}
	cout << endl;
}

int main()
{
	int t;
	cin >> t;
	for(int i = 0; i < t; i++)
		solve();
	//cin >> t;
	return 0;
}