#include <iostream>
#include <queue>
#include <algorithm>
#include <vector>

using namespace std;

int const LIM = 210, INF = 1e9;

int d[LIM], p[LIM], n, m;
bool used[LIM];
vector<int> g[LIM];

int main() {
    ios_base::sync_with_stdio(false);
    int t;
    cin >> t;
    while (t--) {
        cin >> n >> m;
        for (int i = 0; i < n; ++i) {
            g[i].clear();
        }
        for (int i = 0; i < m; ++i) {
            int u, v;
            cin >> u >> v;
            --u; --v;

            g[u].push_back(v);
            g[v].push_back(u);
        }
        int ans = INF;
        for (int i = 0; i < n; ++i) {
            fill(used, used + n, false);
            d[i] = 0;
            p[i] = i;
            used[i] = true;
            queue<int> q;
            q.push(i);
            while (!q.empty()) {
                int u = q.front();
                q.pop();
                for (int v : g[u]) {
                    if (!used[v]) {
                        p[v] = u;
                        d[v] = d[u] + 1;
                        used[v] = true;
                        q.push(v);
                    } else if (v != p[u]) {
                        ans = min(ans, d[u] + d[v] + 1);
                    }
                }
            }
        }
        cout << ans << endl;
    }
    return 0;
}
