#include <iostream>
#include <iomanip>
#include <string>
#include <cmath>
#include <vector>
#include <algorithm>
#include <ctime>

using namespace std;

typedef long long ll;

const int N = 1e5 + 100;
int F[N];
inline void add(int x){
	for (int i = x; i < N; i += i & -i)
		++F[i];
}
inline int getsum(int x){
	int ans = 0;
	for (int i = x; i > 0; i -= i & -i)
		ans += F[i];
	return ans;
}

int ans[N];
int b[N];
inline void solve(){
	int n; cin >> n;
	fill(F, F + n + 2, 0);
	for (int i = 0; i < n; ++i)
		cin >> b[i];
	for (int j = n - 1; j >= 0; --j){
		ans[j] = getsum(b[j]);
		add(b[j]);
	}
	for (int j = 0; j < n; ++j)
		cout << ans[j] << ' ';
	cout << endl;
}

int main()
{
	ios_base::sync_with_stdio(false);
	int n;
	cin >> n;
	for (int i = 0; i < n; ++i){
		solve();
	}
	return 0;
}