#include <iostream>
#include <iomanip>
#include <string>
#include <cmath>
#include <vector>
#include <algorithm>
#include <ctime>

using namespace std;

typedef long long ll;

const int N = 1e5 + 100;
ll n, k;
ll T[N];

inline ll cnt(ll t){
	ll ans =  0;
	for (int i = 0; i < n; ++i)
		ans += t / T[i];
	return ans;
}

inline void solve(){
	cin >> n >> k;
	for (int i = 0; i < n; ++i)
		cin >> T[i];
	ll l = 0, r = 2e9;
	while (r - l > 1){
		ll m = (r + l) / 2;
		if (cnt(m) >= k) r = m;
		else l = m;
	}
	cout << r << endl;
}

int main()
{
	ios_base::sync_with_stdio(false);
	int ttt;
	cin >> ttt;
	for (int i = 0; i < ttt; ++i){
		solve();
	}
	return 0;
}