#include <iostream>
#include <iomanip>
#include <string>
#include <cmath>
#include <vector>
#include <algorithm>
#include <ctime>
#include <unordered_map>

using namespace std;

typedef long long ll;

const int N = 1e5 + 100;
ll K;

unordered_map<ll, bool> mmap;
inline bool solve(ll num){
	if (num >= K) return false;
	auto it = mmap.find(num);
	if (it != mmap.end()) return it->second;
	bool ans = false;
	for (int i = 2; !ans && i < 10; ++i)
		ans = !solve(num * i);
	mmap[num] = ans;
	return ans;
}

int main(){
	ios_base::sync_with_stdio(false);
	int ttt;
	cin >> ttt;
	for (int i = 0; i < ttt; ++i){
		cin >> K;
		mmap.clear();
		cout << (solve(1)? 1 : 2) << endl;
	}
	return 0;
}