#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <cassert>
#include <ctime>
#include <cstring>
#include <algorithm>
#include <iostream>
#include <set>
#include <map>
#include <vector>
#include <queue>
#include <deque>
using namespace std;
#define pb push_back
#define mp make_pair
#define sc second
#define fs first
#define int64 long long
#define ldb long double
#define sz(a) ((int) (a).size())
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
const int M = 2017;

int inva[100], n, k, t;

int pow(int a, int b) {
	if (b == 0) return 1;
	if (b & 1) return (pow(a, b - 1) * (int64) a) % M;
	int tmp = pow(a, b / 2);
	return (tmp * (int64) tmp) % M;
}

int inversik(int x) {
	return pow(x, M - 2);
}

int main() {
	//assert(freopen("input.txt", "r", stdin));
	//assert(freopen("output.txt", "w", stdout));
	inva[0] = 1;
	for (int i = 1; i <= 10; ++i) {
		inva[i] = inversik(i);
		assert((i * inva[i]) % M  == 1);
	}
	scanf("%d", &t);
	for (int it = 0; it < t; ++it) {
		scanf("%d%d", &n, &k);
		int sum = 0, cnk = 1;
		for (int i = 0, sign = 1; i <= k; ++i, sign *= -1) {
			sum = (sum + (cnk * sign * pow(k - i, n)) % M + M) % M;
			cnk = ((cnk * (int64) (k - i)) % M * inva[i + 1]) % M;
		}
		for (int i = 1; i <= k; ++i)
			sum = (sum * inva[i]) % M;
		printf("%d\n", sum);
	}
	return 0;
}