#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <ctime>
#include <cstring>
#include <cassert>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <stack>
#include <queue>
#include <deque>
#include <complex>
#include <unordered_map>

using namespace std;

#define pb push_back
#define mp make_pair
#define sz(s) int((s).size())
#define len(s) int((s).size())
#define all(s) (s).begin(), (s).end()
#ifdef _WIN32
#define LLD "%I64d"
#else
#define LLD "%lld"
#endif
#ifdef LOCAL42
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#else
#define eprintf(...) 42
#endif
#define y0 yy0
#define y1 yy1
#define next _next
#define prev _prev
#define rank _rank
#define link _link
#define hash _hash
#define fs first
#define sc second

typedef long long ll;
typedef long long llong;
typedef long long int64;
typedef unsigned int uint;
typedef long double ld;
typedef unsigned long long ull;
typedef unsigned long long ullong;
typedef unsigned long long lint;
typedef pair<int, int> pii;
typedef vector<int> vi;

const int inf = int(1e9);
const double eps = 1e-9;
const double pi = 4 * atan(double(1));
const int MOD = (1 << 22);
const int SIZE = int(1e6);

int n, sz = 0, cur_ver = 0;
int ver[MOD], first[MOD];
bool sol[SIZE];
int val[SIZE], next[SIZE];

inline bool find(int cur, bool &res) {
	int need = cur & (MOD - 1);
	if (ver[need] != cur_ver) {
		ver[need] = cur_ver;
		first[need] = 0;
	}
	for (int i = first[need]; i > 0; i = next[i]) {
		if (val[i] == cur) {
			res = sol[i];
			return true;
		}
	}
	return false;
}

inline void massert(bool fl) {
	if (!fl) {
		cerr << "FUCK" << endl;
		exit(123);
	}
}

inline bool add(int cur, bool s) {
	int need = cur & (MOD - 1);
	//massert(sz + 1 < SIZE);
	val[++sz] = cur;
	sol[sz] = s;
	next[sz] = first[need];
	first[need] = sz;
	return s;
}

bool can(int cur) {
	bool res;
	if (find(cur, res)) {
		return res;
	}
	for (int i = 2; i < 10; ++i) {
		if (1LL * i * cur >= n) {
			return add(cur, true);
		} else {
			if (!can(i * cur)) {
				return add(cur, true);
			}
		}
	}
	return add(cur, false);
}

inline void solve() {
	++cur_ver;
	sz = 0;
	n = int(1e9);
	//scanf("%d", &n);
	if (can(1)) {
		puts("1");
	} else {
		puts("2");
	}
}

int main() {
#ifdef LOCAL42
#define TASK "G"
	freopen(TASK ".in", "r", stdin);
	freopen(TASK ".out", "w", stdout);
#else

#endif
	int t;
	scanf("%d", &t);
	for (int i = 0; i < t; ++i) {
		solve();
	}
	cerr << 1.0 * clock() / CLOCKS_PER_SEC << endl;
	return 0;
}
