#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <ctime>
#include <cstring>
#include <cassert>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <stack>
#include <queue>
#include <deque>
#include <complex>

using namespace std;

#define pb push_back
#define mp make_pair
#define sz(s) int((s).size())
#define len(s) int((s).size())
#define all(s) (s).begin(), (s).end()
#ifdef _WIN32
#define LLD "%I64d"
#else
#define LLD "%lld"
#endif
#ifdef LOCAL42
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#else
#define eprintf(...) 42
#endif
#define y0 yy0
#define y1 yy1
#define next _next
#define prev _prev
#define rank _rank
#define link _link
#define hash _hash
#define fs first
#define sc second

typedef long long ll;
typedef long long llong;
typedef long long int64;
typedef unsigned int uint;
typedef long double ld;
typedef unsigned long long ull;
typedef unsigned long long ullong;
typedef unsigned long long lint;
typedef pair<int, int> pii;
typedef vector<int> vi;

const int inf = int(1e9);
const double eps = 1e-9;
const double pi = 4 * atan(double(1));

int main() {
#ifdef LOCAL42
#define TASK "H"
	freopen(TASK ".in", "r", stdin);
	freopen(TASK ".out", "w", stdout);
#else

#endif
	int t; scanf("%d", &t);
	while (t-- > 0) {
		int n; scanf("%d", &n);
		if (n == 0) {
			puts("0");
			continue;
		}
		vector<int> a(n);
		for (int i = 0; i < n; i++)
			scanf("%d", &a[i]);
		int ans = 0;
		while (*max_element(all(a)) > 0) {
			if (*max_element(all(a)) <= 18) {
				for (int i = 0; i < n; i++) {
					if (a[i] == 0)
						continue;
					if (a[i] <= 9)
						ans++;
					else
						ans += 2;
				}
				break;
			}
			for (int i = 0; i < n; i++) {
				if (a[i] % 10 != 0) {
					ans++;
					a[i] -= a[i] % 10;
				}
			}
			ans++;
			for (int i = 0; i < n; i++) {
				a[i] /= 10;
			}
		}
		printf("%d\n", ans);
	}
	return 0;
}
