#include <iostream>
#include <fstream>
#include <ctime>
#include <cstdio>
#include <vector>
#include <map>
#include <algorithm>
#include <set>
#include <cstdlib>
#include <cstring>
#include <cmath>
#include <bitset>
#include <deque>
#include <stack>
#include <queue>
using namespace std;

#define fs first
#define sc second

#define pb push_back
#define mp make_pair

#define forn(i, n) for(int i = 0; i < (int)n; ++i)
#define all(x) (x).begin(), (x).end()

const int MAXN = 100 * 1000 + 5, MAXK = 105, MOD = 1000 * 1000 * 1000;
char used[MAXN];
int a[MAXK], b[MAXK], dp[MAXN];
vector<int> g[MAXN];

int dfs(int v) {
    if(used[v])
        return dp[v];
    used[v] = true;
    dp[v] = 0;
    for(size_t i = 0; i < g[v].size(); i++)
        dp[v] = (dp[v] + dfs(g[v][i])) % MOD;
    return dp[v];
}

int main()
{
    ios_base::sync_with_stdio(false);
    int t;
    cin >> t;
    for(int tt = 0; tt < t; tt++) {
        int n, m;
        cin >> n >> m;
        for(int i = 0; i <= m; i++) {
            g[i].clear();
            used[i] = false;
        }
        int k;
        cin >> k;
        for(int i = 0; i < k; i++)
            cin >> a[i];
        sort(a, a + k);
        k = unique(a, a + k) - a;
        int s;
        cin >> s;
        for(int i = 0; i < s; i++)
            cin >> b[i];
        sort(b, b + s);
        s = unique(b, b + s) - b;
        for(int i = 1; i <= m; i++) {
            for(int j = 0; j < k; j++)
                if(i + a[j] < m)
                    g[i].push_back(i + a[j]);
            for(int j = 0; j < s; j++)
                if(i * b[j] <= m)
                    g[i].push_back(i * b[j]);
        }
        dp[m] = 1;
        used[m] = true;
        cout << dfs(n) << '\n';;
    }
    return 0;
}
