#include <cstdio>
#include <iostream>
#include <vector>
#include <algorithm>
#include <cstring>
#include <string>
#include <cmath>
#include <map>
#include <set>
#include <climits>
#include <cassert>
#include <cctype>
#include <queue>
#include <ctime>
using namespace std;

typedef long long ll;
typedef double dbl;
typedef long double ld;

#define mp make_pair
#define pb push_back
#define sz(x) (int)x.size()
#define all(x) x.begin(),x.end()
#define X first
#define Y second

const ll maxn = 1000*100 + 10;
const dbl eps = 1e-9;
const int mod = 2017;

int a[maxn];
int tree[maxn];

void add(int pos, int val) {
	for (; pos < maxn; pos += pos & -pos)
		tree[pos] += val;
}

int sum(int pos) {
	int res = 0;
	for (; pos > 0; pos -= pos & -pos)
		res += tree[pos];
	return res;
}

int main() {
#ifdef _MBCS
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	
/*	int t;
	scanf("%d", &t);
	for (int i = 0; i < t; i++) {
		int n, k;
		scanf("%d%d", &n, &k);
		vector<int> v(n);
		for (int j = 0; j < n; j++)
			scanf("%d", &v[j]);
		ll l = -1, r = 2 * (ll)1e18 + 2;
		while (r - l > 1) {
			ll mid = (r + l) / 2;
			ll ans = 0;
			for (int j = 0; j < n; j++)
				ans += mid / v[j];
			if (ans < k) l = mid;
			else r = mid;
		}
		printf("%lld\n", r);
	}
	*/
	int t;
	scanf("%d", &t);
	for (int j = 0; j < t; j++) {
		int n;
		scanf("%d", &n);
		for (int i = 0; i < n; i++)
			scanf("%d", &a[i]);
		for (int i = 0; i < 100001; i++)
			tree[i] = 0;
		for (int i = 1; i < n; i++)
			add(a[i], 1);
		for (int i = 0; i < n - 1; i++) {
			printf("%d ", sum(a[i] - 1));
			add(a[i], -1);
		}
		printf("%d\n", sum(a[n - 1] - 1));
	}

	return 0;
}