#define _CRT_SECURE_NO_WARNINGS
#define _USE_MATH_DEFINES
#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>
#include <limits.h>
#include <queue>
#include <stack>
#include <deque>
#include <set>
#include <map>
#include <hash_set>
#include <hash_map>
#include <utility>
#include <stdio.h>
#include <time.h>
#include <memory.h>
#include <string.h>
#include <assert.h>
using namespace std;

#define EPS 1E-7
#define MOD 1000000007
#define mp make_pair
#define pb push_back

int n,m;
vector<int>used(300);
vector<int>color(300);
vector<int>d(300);
vector<vector<int>>g;

int best = 9999999;

void dfs(int v, int len, int from){
	color[v]=1;
	for(int i=0; i<g[v].size(); ++i){
		int to = g[v][i];
		if(to==from)continue;

		if(color[to]==1){
			best = min(best, len+1);
		}
		else if(color[to]==0){
			dfs(to,len+1,v);
		}
	}
	color[v]=2;
}

void dfs1(int v, int from, int len){
	for(int i=0; i<g[v].size(); ++i){
		int to = g[v][i];
		if(to==from)continue;
		if(used[to]){
			best = min(best, len+1);
			if(best==3){
				return;
			}
		}
		else{
			used[to]=1;
			dfs1(to,v,len+1);
			used[to]=0;
		}
	}
}


int main(){
	freopen("input.txt","r",stdin); freopen("output.txt","w",stdout);
	int t;
	cin>>t;
	for(int T=0;T<t;++T){
		cin>>n>>m;
		best = 9999999;
		g.clear();
		g.resize(n);
		color.assign(n,0);
		int u,v;
		for(int i=0; i<m; ++i){
			scanf("%d%d", &u,&v);
			g[u-1].push_back(v-1);
			g[v-1].push_back(u-1);
		}
		for(int i=0; i<n; ++i){
			d.assign(n,0);
			color.assign(n,0);
			used.assign(n,0);
			used[i]=1;
			dfs1(i,-1,0);
			if(best==3)break;
		}
		cout << best << endl;
	}

	return 0;
}
