#include <iostream>
#include <algorithm>
#include <set>
#include <map>
#include <string>
#include <cstring>
#include <cstdio>
#include <ctime>
#include <cassert>
#include <vector>
#include <queue>
#include <cmath>

using namespace std;

const long long INF = 1e9;
const int N = 500500;

long long f[N];
int tt, n, cnt;
pair<long long, long long> ans;

long long gcd(long long a, long long b) {
	while ((a > 0) && (b > 0)) {
		if (a > b) a %= b; 
		else b %= a;
	}
	return a + b;
}

void get(long long a, long long b, long long c, long long &x, long long &y) {
	if (b == 0) {
		x = c / a;
		y = 0;
		return;
	}
	long long q = a / b;
	long long x2, y2;
	get(b, a - q * b, c, x2, y2);
	x = y2;
	y = x2 - q * y2;
}

bool solve(long long a, long long b, long long &x, long long &y, long long c) {
	long long d = gcd(a, b);
	if (c % d != 0) return false;
	get(a, b, c, x, y);
	return true;
}

void check(long long x, long long y) {
	if ((x <= y) && (x > 0)) ans = min(ans, make_pair(y, x));
}

int main() {
	freopen("input.txt", "r" ,stdin);
	f[0] = 0;
	f[1] = 1;
	for (int i = 2; f[i - 1] <= INF; i++) {
		f[i] = f[i - 1] + f[i - 2];
		cnt = i;
	}
	scanf("%d", &tt);
	while (tt--) {
		scanf("%d", &n);
		ans = make_pair(n - 1, 1);
		for (int i = 3; i <= cnt; i++) {
			long long x, y;
			bool res = solve(f[i - 2], f[i - 1], x, y, n);
			if (!res) continue;
			//f[i - 2] * x + f[i - 1] * y == n
			long long t = (y - x) / f[i];
			for (int e = t - 2; e <= t + 2; e++) check(x + f[i - 1] * e, y - f[i - 2] * e);
		}
		cout << ans.second << " " << ans.first << endl;
	}
}




